
  function [] = plotresp_residual(ifg,mdtp,nres,nper,period,nsta,staloc,restyp,calres,obsres, ...
                hsv2,mxsc,mnsc,mxrsc,mnrsc)

  figure(ifg); clf;
  if (mdtp == 1), set(gcf,'Name','OBSERVED AND CALCULATED RESPONSE : TM'); end;
  if (mdtp == 2), set(gcf,'Name','OBSERVED AND CALCULATED RESPONSE : TE'); end;
  if (mdtp == 3), set(gcf,'Name','OBSERVED AND CALCULATED RESPONSE : TP'); end;
  set(gcf,'Unit','Normalized','Position',[0.5 0.4 0.5 0.5]);
  colormap(hsv2);

  nptk = round(nper/6);
  ytk  = [nper:-nptk:1];
  ytl  = sprintf('%8.3f',period(nper));
  for ipp = nper-nptk:-nptk:1
    ytl  = [ytl;  sprintf('%8.3f',period(ipp))]; 
  end;   
  ytk = [1:nptk:nper]+0.5; 


  for ir = 1:nres
    if (restyp(ir) == 3)
      subplot(3,2,ir);
      if (mxsc(ir) == 0), mx1 = max(max(obsres(1:nsta,1:nper,ir))); 
      else  mx1 = mxsc(ir);  end;
      if (mnsc(ir) == 0), mn1 = min(min(obsres(1:nsta,1:nper,ir)));
      else  mn1 = mnsc(ir);  end;
      rtmp = obsres(1:nsta,1:nper,ir);
      rtmp(nsta+1,1:nper) = rtmp(nsta,1:nper);
      rtmp(1:nsta+1,nper+1) = rtmp(1:nsta+1,nper);
      pcolor(1:nsta+1,nper+1:-1:1,rtmp'); shading flat;
      caxis([mn1 mx1]); colorbar('vert');
      set(gca,'TickDirMode','manual','TickDir','out');
      if (ir ~= 2)
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel',ytl);
      else
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel','');
      end
      set(gca,'XTickLabelMode','manual','XTickLabel','');
      ylabel('Period (s)'); 
      title('Observed log10 \rho_{a}');   

      subplot(3,2,ir+2);
      rtmp = calres(1:nsta,1:nper,ir);
      rtmp(nsta+1,1:nper) = rtmp(nsta,1:nper);
      rtmp(1:nsta+1,nper+1) = rtmp(1:nsta+1,nper);
      pcolor(1:nsta+1,nper+1:-1:1,rtmp'); shading flat;
      caxis([mn1 mx1]); colorbar('vert');
      set(gca,'TickDirMode','manual','TickDir','out');
      if (ir ~= 2)
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel',ytl);
      else
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel','');
      end
      set(gca,'XTickLabelMode','manual','XTickLabel','');
      ylabel('Period (s)'); 
      title('Calculated log10 \rho_{a}'); 

      subplot(3,2,ir+4);
      rtmp = obsres(1:nsta,1:nper,ir) - calres(1:nsta,1:nper,ir);
      if (mxrsc(ir) == 0), mx1 = max(rtmp(:));     
      else  mx1 = mxrsc(ir);  end;
      if (mnrsc(ir) == 0), mn1 = min(rtmp(:));
      else  mn1 = mnrsc(ir);  end;
      rtmp(nsta+1,1:nper)   = rtmp(nsta,1:nper);
      rtmp(1:nsta+1,nper+1) = rtmp(1:nsta+1,nper);
      pcolor(1:nsta+1,nper+1:-1:1,rtmp'); shading flat;
      caxis([mn1 mx1]); colorbar('vert');
      set(gca,'TickDirMode','manual','TickDir','out');
      if (ir ~= 2)
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel',ytl);
      else
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel','');
      end
      ylabel('Period (s)'); 
      title('Residual log10 \rho_{a}'); xlabel('Stations No.');
    end

    if (restyp(ir) == 1)
      subplot(3,2,ir);
      if (mxsc(ir) == 0), mx1 = max(max(obsres(1:nsta,1:nper,ir))); 
      else  mx1 = mxsc(ir);  end;
      if (mnsc(ir) == 0), mn1 = min(min(obsres(1:nsta,1:nper,ir)));
      else  mn1 = mnsc(ir);  end;
      rtmp = obsres(1:nsta,1:nper,ir);
      rtmp(nsta+1,1:nper) = rtmp(nsta,1:nper);
      rtmp(1:nsta+1,nper+1) = rtmp(1:nsta+1,nper);
      pcolor(1:nsta+1,nper+1:-1:1,log10(rtmp)'); shading flat;
      caxis([mn1 mx1]); colorbar('vert');
      set(gca,'TickDirMode','manual','TickDir','out');
      if (ir ~= 2)
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel',ytl);
      else
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel','');
      end
      set(gca,'XTickLabelMode','manual','XTickLabel','');
      ylabel('Period (s)'); 
      title('Observed log10 \rho_{a}');   

      subplot(3,2,ir+2);
      rtmp = calres(1:nsta,1:nper,ir);
      rtmp(nsta+1,1:nper) = rtmp(nsta,1:nper);
      rtmp(1:nsta+1,nper+1) = rtmp(1:nsta+1,nper);
      pcolor(1:nsta+1,nper+1:-1:1,log10(rtmp)'); shading flat;
      caxis([mn1 mx1]); colorbar('vert');
      set(gca,'TickDirMode','manual','TickDir','out');
      if (ir ~= 2)
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel',ytl);
      else
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel','');
      end
      set(gca,'XTickLabelMode','manual','XTickLabel','');
      ylabel('Period (s)'); 
      title('Calculated log10 \rho_{a}');

      subplot(3,2,ir+4);
      rtmp = log10(obsres(1:nsta,1:nper,ir)) - log10(calres(1:nsta,1:nper,ir));
      if (mxrsc(ir) == 0), mx1 = max(rtmp(:));     
      else  mx1 = mxrsc(ir);  end;
      if (mnrsc(ir) == 0), mn1 = min(rtmp(:));
      else  mn1 = mnrsc(ir);  end;
      rtmp(nsta+1,1:nper)   = rtmp(nsta,1:nper);
      rtmp(1:nsta+1,nper+1) = rtmp(1:nsta+1,nper);
      pcolor(1:nsta+1,nper+1:-1:1,rtmp'); shading flat;
      caxis([mn1 mx1]); colorbar('vert');
      set(gca,'TickDirMode','manual','TickDir','out');
      if (ir ~= 2)
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel',ytl);
      else
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel','');
      end
      ylabel('Period (s)'); 
      title('Residual log10 \rho_{a}'); xlabel('Stations No.');
    end
   
    if (restyp(ir) == 2)
      subplot(3,2,ir); 
      if (mxsc(ir) == 0), mx2 = max(max(obsres(1:nsta,1:nper,ir))); 
      else  mx2 = mxsc(ir);  end;
      if (mnsc(ir) == 0), mn2 = min(min(obsres(1:nsta,1:nper,ir)));
      else  mn2 = mnsc(ir);  end;
      rtmp = -obsres(1:nsta,1:nper,ir);
      rtmp(nsta+1,1:nper) = rtmp(nsta,1:nper);
      rtmp(1:nsta+1,nper+1) = rtmp(1:nsta+1,nper);
      pcolor(1:nsta+1,nper+1:-1:1,rtmp'); shading flat;
      caxis([-mx2 -mn2]); cb = colorbar('vert');
      set(gca,'TickDirMode','manual','TickDir','out');
      if (ir ~= 2)
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel',ytl);
      else
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel','');
      end
      set(gca,'XTickLabelMode','manual','XTickLabel','');
      ylabel('Period (s)'); 
      cbtk = get(cb,'YTick'); 
      cbtl = sprintf('%5.1f',abs(cbtk(1)));
      for ic = 2:length(cbtk) 
        cbtl  = [cbtl;  sprintf('%5.1f',abs(cbtk(ic)))];
      end;
      set(cb,'YTickLabelMode','manual','YTickLabel',cbtl);
      title('Observed \phi_{a}');   

      subplot(3,2,ir+2); 
      rtmp = -calres(1:nsta,1:nper,ir);
      rtmp(nsta+1,1:nper) = rtmp(nsta,1:nper);
      rtmp(1:nsta+1,nper+1) = rtmp(1:nsta+1,nper);
      pcolor(1:nsta+1,nper+1:-1:1,rtmp'); shading flat;
      caxis([-mx2 -mn2]); cb = colorbar('vert');
      set(gca,'TickDirMode','manual','TickDir','out');
      if (ir ~= 2)
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel',ytl);
      else
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel','');
      end
      set(gca,'XTickLabelMode','manual','XTickLabel','');
      ylabel('Period (s)'); 
      cbtk = get(cb,'YTick'); 
      cbtl = sprintf('%5.1f',abs(cbtk(1)));
      for ic = 2:length(cbtk) 
        cbtl  = [cbtl;  sprintf('%5.1f',abs(cbtk(ic)))];
      end;
      set(cb,'YTickLabelMode','manual','YTickLabel',cbtl);
      title('Calculated \phi_{a}'); 

      subplot(3,2,ir+4);
      rtmp = obsres(1:nsta,1:nper,ir) - calres(1:nsta,1:nper,ir);
      if (mxrsc(ir) == 0), mx1 = max(rtmp(:));     
      else  mx1 = mxrsc(ir);  end;
      if (mnrsc(ir) == 0), mn1 = min(rtmp(:));
      else  mn1 = mnrsc(ir);  end;
      rtmp(nsta+1,1:nper)   = rtmp(nsta,1:nper);
      rtmp(1:nsta+1,nper+1) = rtmp(1:nsta+1,nper);
      pcolor(1:nsta+1,nper+1:-1:1,rtmp'); shading flat;
      caxis([mn1 mx1]); colorbar('vert');
      set(gca,'TickDirMode','manual','TickDir','out');
      if (ir ~= 2)
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel',ytl);
      else
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel','');
      end
      ylabel('Period (s)'); 
      title('Residual \phi_{a}'); xlabel('Stations No.');
    end

    if (restyp(ir) == 5) | (restyp(ir) == 6)
      subplot(3,2,ir); 
      if (mxsc(ir) == 0), mx2 = max(max(obsres(1:nsta,1:nper,ir))); 
      else  mx2 = mxsc(ir);  end;
      if (mnsc(ir) == 0), mn2 = min(min(obsres(1:nsta,1:nper,ir)));
      else  mn2 = mnsc(ir);  end;
      rtmp = obsres(1:nsta,1:nper,ir);
      rtmp(nsta+1,1:nper) = rtmp(nsta,1:nper);
      rtmp(1:nsta+1,nper+1) = rtmp(1:nsta+1,nper);
      pcolor(1:nsta+1,nper+1:-1:1,rtmp'); shading flat;
      set(gca,'TickDirMode','manual','TickDir','out');
      if (ir ~= 2)
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel',ytl);
      else
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel','');
      end
      ylabel('Period (s)'); 
      set(gca,'XTickLabelMode','manual','XTickLabel','');
      caxis([-mx2 -mn2]); colorbar('vert');
      if (restyp(ir) == 5), title('Observed \Re(TP) ');  end;
      if (restyp(ir) == 6), title('Observed \Im(TP) ');  end;

      subplot(3,2,ir+2); 
      rtmp = calres(1:nsta,1:nper,ir);
      rtmp(nsta+1,1:nper) = rtmp(nsta,1:nper);
      rtmp(1:nsta+1,nper+1) = rtmp(1:nsta+1,nper);
      pcolor(1:nsta+1,nper+1:-1:1,rtmp'); shading flat;
      set(gca,'TickDirMode','manual','TickDir','out');
      if (ir ~= 2)
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel',ytl);
      else
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel','');
      end
      set(gca,'XTickLabelMode','manual','XTickLabel','');
      ylabel('Period (s)'); 
      caxis([-mx2 -mn2]); colorbar('vert');
      if (restyp(ir) == 5), title('Calculated \Re(TP) ');  end;
      if (restyp(ir) == 6), title('Calculated \Im(TP) ');  end;

      subplot(3,2,ir+4);
      rtmp = obsres(1:nsta,1:nper,ir) - calres(1:nsta,1:nper,ir);
      if (mxrsc(ir) == 0), mx1 = max(rtmp(:));     
      else  mx1 = mxrsc(ir);  end;
      if (mnrsc(ir) == 0), mn1 = min(rtmp(:));
      else  mn1 = mnrsc(ir);  end;
      rtmp(nsta+1,1:nper)   = rtmp(nsta,1:nper);
      rtmp(1:nsta+1,nper+1) = rtmp(1:nsta+1,nper);
      pcolor(1:nsta+1,nper+1:-1:1,rtmp'); shading flat;
      caxis([mn1 mx1]); colorbar('vert');
      set(gca,'TickDirMode','manual','TickDir','out');
      if (ir ~= 2)
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel',ytl);
      else
        set(gca,'YTickMode','manual','YTick',ytk);
        set(gca,'YTickLabelMode','manual','YTickLabel','');
      end
      ylabel('Period (s)'); 
      xlabel('Stations No.');
      if (restyp(ir) == 5), title('Residual \Re(TP) ');  end;
      if (restyp(ir) == 6), title('Residual \Im(TP) ');  end;
    end

  end

  return
