

  function [] = plotrms(ifg,mdtp,nres,restyp,nper,period,nsta,rmss,rmsp)

  figure(ifg); clf;
  if (mdtp == 1), set(gcf,'Name','ROOT MEAN SQUARE ERROR : TM'); end;
  if (mdtp == 2), set(gcf,'Name','ROOT MEAN SQUARE ERROR : TE'); end;
  if (mdtp == 3), set(gcf,'Name','ROOT MEAN SQUARE ERROR : TP'); end;
  set(gcf,'Unit','Normalized','Position',[0.5 0.0 0.5 0.5]);

  nptk = round(nper/6);
  ytk  = [nper:-nptk:1];
  ytl  = sprintf('%8.3f',period(nper));
  for ipp = nper-nptk:-nptk:1
    ytl  = [ytl;  sprintf('%8.3f',period(ipp))];
  end;
  ytk = 1:nptk:nper; 

  for ir = 1:nres
    subplot(2,2,ir);
    plot(rmsp(:,ir),nper:-1:1,'+-');
    ylabel('Period (s)');
    xlabel('RMS');
    set(gca,'TickDirMode','manual','TickDir','out');
    if (ir ~= 2)
      set(gca,'YTickMode','manual','YTick',ytk);
      set(gca,'YTickLabelMode','manual','YTickLabel',ytl);
    else
      set(gca,'YTickMode','manual','YTick',ytk);
      set(gca,'YTickLabelMode','manual','YTickLabel','');
    end
    mxrms = max(rmsp(:,ir)); mnrms = min(rmsp(:,ir));
    axis([mnrms mxrms 1 nper]);
    if (restyp(ir) == 3) | (restyp(ir) == 1), title('Apparent Resistivity'); end;
    if (restyp(ir) == 2) | (restyp(ir) == 4), title('Phase'); end;
    if (restyp(ir) == 5), title('Real Part Tipper'); end;
    if (restyp(ir) == 6), title('Imag Part Tipper'); end;


    subplot(2,2,ir+2);
    plot(1:nsta,rmss(:,ir),'x-');
    xlabel('Station No.');
    ylabel('RMS');
    mxrms = max(rmss(:,ir)); mnrms = min(rmss(:,ir));
    axis([1 nsta mnrms mxrms]);
  end

  return;

