

     function [chresp,modtyp,nres,nper,period,nsta,staloc,restyp,datres,errres] ...
              = readdatafile(cdf);

     fid = fopen(cdf,'r');

%    reading header file 
     chresp = fgets(fid); 

%    read mode type
     ctemp  = fgets(fid);   ct2 = lower(ctemp);
     if (findstr(ct2,'tm') > 0), modtyp = 1; end;
     if (findstr(ct2,'te') > 0), modtyp = 2; end;
     if (findstr(ct2,'tp') > 0), modtyp = 3; end;
     
%    read number of response
     ctemp  = fgets(fid);     
     nres   = str2num(ctemp(19:length(ctemp)));

%    read number of period or frequency
     ctemp  = fgets(fid);   ct2 = lower(ctemp);
     if (findstr(ct2,'frequency') > 0),
        nper   = str2num(ctemp(20:length(ctemp)));
     else
        nper   = str2num(ctemp(19:length(ctemp)));
     end

     if (findstr(ct2,'period') > 0),
        period(1:nper) = fscanf(fid,'%f',nper);
     end
     if (findstr(ct2,'frequency') > 0),
        freq = fscanf(fid,'%f',nper);
        period(1:nper) = 1./freq;   
     end

%    read number of station
     ctemp  = fgets(fid);  ctemp  = fgets(fid);  
     nsta   = str2num(ctemp(19:length(ctemp)));
     staloc(1:nsta) = fscanf(fid,'%f',nsta);

%    read response types
     for ir = 1:nres
       ctemp  = fgets(fid); 
       ctemp  = fgets(fid); ct2 = lower(ctemp);
       if (findstr(ct2,'app') > 0), restyp(ir) = 1; end;
       if (findstr(ct2,'phs') > 0), restyp(ir) = 2; end;
       if (findstr(ct2,'rel') > 0), restyp(ir) = 5; end;
       if (findstr(ct2,'img') > 0), restyp(ir) = 6; end;
       if (restyp(ir) == 1)
          if (findstr(ct2,'log') > 0), restyp(ir) = 3; end;
       end
       if (restyp(ir) == 2)
          if (findstr(ct2,'deg') > 0), restyp(ir) = 2; end;
          if (findstr(ct2,'rad') > 0), restyp(ir) = 4; end;
       end

       clear dtmp
       dtmp  = fscanf(fid,'%f',[nsta+1 nper]);
       datres(1:nsta,1:nper,ir) = dtmp(2:nsta+1,1:nper);

       ctemp  = fgets(fid); 
       ctemp  = fgets(fid); 
       clear dtmp
       dtmp  = fscanf(fid,'%f',[nsta+1 nper]);
       errres(1:nsta,1:nper,ir) = dtmp(2:nsta+1,1:nper);
     end     
     ctemp  = fgets(fid);

     for ir = 1:nres
       ctemp  = fgets(fid);
       for ip = 1:nper
         clear cstr;
         cstr = fgets(fid);  lstr  = length(cstr);
         if (cstr(1:1) == ' '),
           for is = 2:nsta+1, dix(is-1,ip,ir) = str2num(cstr(is:is)); end
         else
           for is = 1:nsta,   dix(is,ip,ir)   = str2num(cstr(is:is)); end
         end
         if (lstr < nsta), cstr = fgets(fid);  lstr = length(cstr)+lstr; end;
       end
     end
 
     inan = find(dix == 0);
     datres(inan) = NaN;
     errres(inan) = NaN;
 
     fclose(fid);
     return
